import java.io.*;

public class TeacherInit {
  public BufferedReader br;

  public TeacherInit() {
    br = new BufferedReader(new InputStreamReader(System.in));
  }

  public final String readLine() {
    try { return br.readLine(); }
    catch (IOException ioe) { return null; }
  }

  public final void writeLine(String line) {
    System.out.println(line);
  }

  public final void write(String line) {
    System.out.print(line);
  }

  public final void run() {
    boolean data = false;
    int j;
    String teacherCode = "", teacherName = "", minLessons = "", maxLessons = "";
    String minHollows = "", maxHollows = "", maxConsec = "", prefs = "";
    do {
      String line = readLine();
      if (line == null)
        break;
      if (line.startsWith("teacherCode: ")) {
        if (data) {
          write("    t = new Teacher(\"" + teacherCode + "\", " + minLessons + ", " + maxLessons + ", " +
                    minHollows + ", " + maxHollows + ", " + maxConsec + ");");
          if (teacherName.length() > 0) writeLine(" t.setDescription(\"" + teacherName + "\");");
          if (prefs.length() > 0) writeLine("    t.setPreferences(\"" + prefs + "\");");
          writeLine("    list.add(t);");
          teacherCode = teacherName = minLessons = maxLessons = minHollows = maxHollows = maxConsec = prefs = "";
        }
        data = true;
        teacherCode = line.substring(13);
      }
      if (line.startsWith("teacherName: "))
        teacherName = line.substring(13);
      if (line.startsWith("preferences: "))
        prefs = line.substring(13);
      if (line.startsWith("lessonsPerDay: ")) {
        line = line.substring(15);
        j = line.indexOf('-');
        if (j > 0) {
          minLessons = line.substring(0, j);
          maxLessons = line.substring(j + 1);
        }
      }
      if (line.startsWith("hollowsPerDay: ")) {
        line = line.substring(15);
        j = line.indexOf('-');
        if (j > 0) {
          minHollows = line.substring(0, j);
          maxHollows = line.substring(j + 1);
        }
      }
      if (line.startsWith("maxConsecutiveLessons: "))
        maxConsec = line.substring(23);
    } while (true);
    if (data) {
      write("    t = new Teacher(\"" + teacherCode + "\", " + minLessons + ", " + maxLessons + ", " +
                minHollows + ", " + maxHollows + ", " + maxConsec + ");");
      if (teacherName.length() > 0) writeLine(" t.setDescription(\"" + teacherName + "\");");
      if (prefs.length() > 0) writeLine("    t.setPreferences(\"" + prefs + "\");");
      writeLine("    list.add(t);");
    }
  }

  public static void main(String args[]) {
    TeacherInit ti = new TeacherInit();
    ti.run();
  } // end of main(String[])


} // end of class TeacherInit
