package examples.maedchen;

import ttclasses.*;
import java.util.*;

/** Girls are allowed to specify friends with who they want to share the same projects. **/
public class FriendsConstraint extends Constraint {
  
  public FriendsConstraint() {
    name = "FriendsConstraint";
  }
  
  public ConstraintViolation compute(PlanningClass owner) {
    Girl g = (Girl)owner;
    List events = g.getEvents();
    List friends = g.friends;
    double akku = 0;
    for (int i = events.size() - 1; i >= 0; i--) {
      Event e = (Event)events.get(i);
      ResourceList rl = e.getResourceList("Girls");
      List assigned = rl.getAssignmentList();
      int j, k;
      for (j = 0; j < friends.size(); j++) {
        boolean found = false;
        String name = (String)friends.get(j);
        for (k = 0; k < assigned.size(); k++) {
          if (((Girl)assigned.get(k)).name.equals(name)) {
            found = true;
            break;
          }
        }
        if (!found) akku++;
      }
    }
    if (akku > 0)
      return new ConstraintViolation(this, owner, "FriendsViolation at " + g.name, akku);
    else
      return null;
  } // end of compute(PlanningClass)
  
  public boolean repair(ConstraintViolation violation) {
    return false;
  }
  
  public int getType() {
    return SOFT_CONSTRAINT;
  }
  
} // end of class FriendsConstraint

