package examples.maedchen;

import ttclasses.*;

/*****
 * <i>GirlsAndTechnology</i> <br> This constraint "assures" that there are no more projects per girl than wished and also
 * that there is at least one project for each of the girls.
 *****/
public class HardProjectConstraint extends Constraint {

  public HardProjectConstraint() {
    name = "HardProjectConstraint";
  }

  public ConstraintViolation compute(PlanningClass owner) {
    int i1 = ((Resource)owner).getAssignmentCount();
    int i2 = ((Girl)owner).firstChoice.size();
    if (i1 > i2)
      return new ConstraintViolation(this, owner, "Too many projects at \"" + owner + "\" (" + i1 + "/" + i2 + ")",  (i1 - i2) * 10);
    if (i1 == 0)
      return new ConstraintViolation(this, owner, "No project for \"" + owner + "\"", 10);
    return null;
  } // end of compute(PlanningClass)

  public boolean repair(ConstraintViolation violation) {
    return false;
  }

  public int getType() {
    return HARD_CONSTRAINT;
  }

} // end of class HardProjectConstraint
