package examples.maedchen;

import ttclasses.*;
import java.util.*;

/*****
 * <i>GirlsAndTechnology</i> <br> <tt>SoftChoiceConstraint</tt> is (as the name suggests) a soft
 * constraint that tries to assure that all girls get their preferred projects.
 *****/
public class SoftChoiceConstraint extends SoftConstraint {

  public SoftChoiceConstraint() {
    name = "SoftChoiceConstraint";
  }

  public ConstraintViolation compute(PlanningClass owner) {
    Girl g = (Girl)owner;
    double penalty = 0;
    String projects = null;
    List events = g.getEvents();
    for (int i = events.size() - 1; i >= 0; i--) {
      Project p = (Project)events.get(i);
      if (!g.firstChoice.contains(p.signature)) {
        penalty += 0.25;
        p.penaltyPoints += 0.25;
        if (projects == null)
	  projects = p.toString();
        else
	  projects += ", " + p.toString();
      }
    }
    if (penalty > 0)
      return new ConstraintViolation(this, owner, "2nd Choice at " + owner + ": " + projects, penalty);
    else
      return null;
  }

  public boolean repair(ConstraintViolation violation) {
    return false;
  }

} // end of class SoftChoiceConstraint
