package examples.maedchen;

import ttclasses.*;

/** <i>GirlsAndTechnology</i> <br> This constraint is violated if a girl
 * gets fewer projects than wished. **/
public class SoftProjectConstraint extends Constraint {

  public SoftProjectConstraint() {
    name = "SoftProjectConstraint";
  }

  public ConstraintViolation compute(PlanningClass owner) {
    int i1 = ((Resource)owner).getAssignmentCount();
    int i2 = ((Girl)owner).firstChoice.size();
    if (i2 > i1)
      return new ConstraintViolation(this, owner, "Too few projects at \"" + owner + "\" (" + i1 + "/" + i2 + ")", 2 * (i2 - i1));
    return null;
  }

  public boolean repair(ConstraintViolation violation) {
    return false;
  }

  public int getType() {
    return SOFT_CONSTRAINT;
  }

} // end of class SoftProjectConstraint
