package examples.school;

import ttclasses.*;
import java.util.*;

public class RoomSizeConstraint extends HardConstraint {

  public RoomSizeConstraint() {
    name = "RoomSizeConstraint";
  }

  public ConstraintViolation compute(PlanningClass owner) {
    int j, k;
    Event ev = (Event)owner;
    ResourceList rl = ev.getResourceList("Class");
    List list = rl.getAssignmentList();
    Clazz clazz = (Clazz)list.get(0);
    rl = ev.getResourceList("Room");
    list = rl.getAssignmentList();
    Room room = (Room)list.get(0);
    if (clazz.size > room.size) {
      ev.penaltyPoints += 50;
      return new ConstraintViolation(this, owner, "RoomSizeViolation at " + ev.name, 50, rl);
    }
    else
      return null;
  }

  public boolean repair(ConstraintViolation violation) {
    ResourceList rooms = (ResourceList)violation.information;
    rooms.mutate();
    return true;
  }

} // end of class RoomSizeConstraint


