package tools.frontend;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.beans.*;

public class SpeciesChooser extends JDialog {
  private TitledBorder titledBorder1;
  private JPanel jPanel2 = new JPanel();
  private JPanel jPanel3 = new JPanel();
  private GridLayout gridLayout1 = new GridLayout();
  private JButton jButton1 = new JButton();
  private JButton jButton2 = new JButton();
  private BorderLayout borderLayout1 = new BorderLayout();
  private JPanel jPanel1 = new JPanel();
  private JLabel jLabel1 = new JLabel();
  private JPanel jPanel4 = new JPanel();
  private BorderLayout borderLayout2 = new BorderLayout();
  private JPanel jPanel5 = new JPanel();
  private List choiceList = new List();
  private JLabel jLabel2 = new JLabel();
  private JTextField initField = new JTextField();
  private GridLayout gridLayout2 = new GridLayout();

  public String species;
  public Frame parent;

  public SpeciesChooser(Frame parent) {
    super(parent);
    this.parent = parent;
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  } // end of SaveDialog(Frame)


  //Component initialization
  private void jbInit() throws Exception {
    this.setTitle("Evolution initialisieren");
    setResizable(true);
    jPanel3.setMaximumSize(new Dimension(32767, 32));
    jPanel3.setMinimumSize(new Dimension(10, 32));
    jPanel3.setPreferredSize(new Dimension(10, 32));
    jPanel3.setLayout(gridLayout1);
    jButton1.setText("Ok");
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton1_actionPerformed(e);
      }
    });
    jButton2.setText("Abbrechen");
    jButton2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton2_actionPerformed(e);
      }
    });
    jPanel2.setLayout(borderLayout1);
    jLabel1.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabel1.setForeground(Color.black);
    jLabel1.setText("Spezies fr den Evolutionsvorgang whlen:");
    jPanel4.setBorder(BorderFactory.createEtchedBorder());
    jPanel4.setLayout(borderLayout2);
    jLabel2.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabel2.setForeground(Color.black);
    jLabel2.setToolTipText("");
    jLabel2.setText(" Initialisierungs-String:  ");
    jPanel5.setLayout(gridLayout2);
    choiceList.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseReleased(MouseEvent e) {
        choiceList_mouseReleased(e);
      }
    });
    choiceList.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        choiceList_keyReleased(e);
      }
    });
    this.getContentPane().add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(jPanel1, BorderLayout.NORTH);
    jPanel1.add(jLabel1, null);
    jPanel2.add(jPanel4, BorderLayout.CENTER);
    jPanel4.add(jPanel5,  BorderLayout.SOUTH);
    jPanel5.add(jLabel2, null);
    jPanel5.add(initField, null);
    jPanel4.add(choiceList, BorderLayout.CENTER);
    choiceList.add("Krankenhaus-Schichtplan (Geriatrie)");
    choiceList.add("Krankenhaus-Schichtplan (Innere)");
    choiceList.add("Mdchen und Technik (2000)");
    choiceList.add("Mdchen und Technik (2001)");
    choiceList.add("Mdchen und Technik (2002)");
    choiceList.add("Schaffer");
    choiceList.add("Schulstundenplan");
    choiceList.add("Travelling Salesperson (n=40)");
    choiceList.add("Travelling Salesperson (n=100)");
    this.getContentPane().add(jPanel3,  BorderLayout.SOUTH);
    jPanel3.add(jButton1, null);
    jPanel3.add(jButton2, null);
  }

  void jButton2_actionPerformed(ActionEvent e) {
    dispose();
  }

  void jButton1_actionPerformed(ActionEvent e) {
    ((MainFrame)parent).species = species;
    ((MainFrame)parent).initString = initField.getText();
    dispose();
  }

  private void updateListSelection() {
    String selection = choiceList.getSelectedItem();
    if (selection.startsWith("Mdchen")) {
      species = "Mdchen und Technik";
      initField.setText("../databases/maedchen/" +
                        selection.substring(selection.length() - 5, selection.length() - 1));
    }
    else if (selection.startsWith("Krankenhaus")) {
      species = "Krankenhaus";
      if (selection.endsWith("(Geriatrie)"))
        initField.setText("../databases/xml/geriatrie_februar.xml");
      else if (selection.endsWith("(Innere)"))
        initField.setText("../databases/xml/innere_februar.xml");
    }
    else if (selection.startsWith("Travelling")) {
      species = "Travelling Salesperson";
      selection = selection.substring(10, selection.length() - 1);
      int index = selection.lastIndexOf('(');
      if (index > 1)
        initField.setText(selection.substring(index + 1));
      else
        initField.setText("");
    }
    else if (selection.startsWith("Schulstundenplan")) {
      species = "Schulstundenplan";
      initField.setText("");
    }
    else if (selection.startsWith("Schaffer")) {
      species = "Schaffer";
      initField.setText("");
    }
    else
      initField.setText("");
  }

  void choiceList_mouseReleased(MouseEvent e) {
    updateListSelection();
  }

  void choiceList_keyReleased(KeyEvent e) {
    updateListSelection();
  }





} // end of class SpeciesChooser
