/**
 * Definition of interface "TTSolver".
 *
 * Author: Stefan Buettcher
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 **/

package ttclasses;

/*****
 * TTSolver blablabla
 *****/

public interface TTSolver {

  /**
   * Calling the <tt>solve()</tt> method lets the actual implementation
   * of <tt>TTSolver</tt> calculate a solution of the scheduling problem,
   * which will then be returned to the caller.
   **/
  public TTProblem solve();
  
  /** Sets the problem so that subsequent solve() calls can work properly. **/
  public void setProblem(TTProblem problem);

} // end of interface TTSolver

